import dev.thebread.Model
import dev.thebread.Model.PreparedStatementCase
import dev.thebread.Models

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.BeforeEach;
import java.sql.DriverManager
import kotlin.test.assertTrue

class DatabaseTests {

    @BeforeEach
    fun setup() {
        val conn = DriverManager.getConnection("jdbc:sqlite::memory:")

        val initSql = javaClass.getResource("/init.sql")!!.readText()
        conn.createStatement().executeUpdate(initSql)

        Model.Common.stmts = PreparedStatementCase.entries.associateWith { case ->
            conn.prepareStatement(
                javaClass.getResource("/prepare/${
                    case.toString().lowercase()
                }.sql")!!.readText()
            )
        }
    }

    @Test
    fun createUser() {
        val user = Models.User()
        user.name = "test"
        user.create()
        assertTrue { user.id != -1 && user.id != null }
        val r = Models.User().get(user.id!!)
        assertTrue { r != null && r.id != null && r.name == user.name }
    }

    @Test
    fun getUser() {
        val user = Models.User().getAll()
    }
}